#!/bin/bash


n=0

echo -n "Enter number of simulated DHT nodes to generate > "
read n
#echo  "Enter number of simulated DHT nodes to generate > "


BEGINFILENAME="config_p"
ENDFILENAME=".txt"

echo "Cleaning... "
killall java
rm Logfile* config* put* 2>/dev/null

echo "Generating Configuration File for Bootstrap... "

echo "# Peer 4
# 1) Change the interface
interface;		eth0
useIPv6;		no	
useHIP;			no
useLocalLoopbackAddr;	no
# Is this peer the bootstrap peer?	
bootstrapMode;		yes
# 2) Change the local port
localPort;		7000
userCommandMode;	no
# 3) Change address of the bootstrap peer
bootstrapPeerIP;	192.168.1.2
bootstrapPeerPort;	7000
randomUserName;		no
userName;		wn0
centralNameAssignment;	no
# This value is in milliseconds
joinDelayInterval;	100
minLookupInterval;	300
maxLookupInterval;	600
minUptime;		288000
maxUptime;		288001	
leaveSupervisionTimer;	30
autoLookupNameRange;	1500
autoLookupSafetyMargin;	50	
successors;		5	
predecessors;		3
fingers;		5
logMode;		WARNING
useDhtCrawler;		yes
dhtCrawlerTimeout;	30
dhtCrawlerTtl;		2048
SIP_USER_AOR;		sip:alice@p2psip.net
sipServerPortLocal;	5067	
sipServerPortPublic;	5066
p2pOverlay;		p2psip.net
dontQueryNonExistUsers;	yes
usePrintServer;		no
printServerIP;		193.167.187.185
printServerPort;	55507
p2ppTimerT0;		5000
# Note: no need to configure T1 since it is initialized to T0
p2ppTimerT2;		30000
p2ppTimerT3;		30000
useTimerT3_B;		yes
# Transaction timer (TCP) for single-hop requests
p2ppTimerT3_B;		15000
usePingServer;		no
pingServerIP;		193.167.187.185
pingServerPort;		19876
maxPingRtt;		2500
disableSIP;		yes
maxAllowedTimeouts;	5
replicationFactor;	0	
# Maintenance timeouts
stabilizeInterval;	30000
fixFingersInterval;	30500
checkPredInterval;	31000
pingFingersInterval;    60000
# Fast startup related parameters
useFastStartUp;		no	
# This value is in milliseconds
joinIntervalFastStart;	4000	
networkSize;		10
measurementDuration;	144000	
# Maintenance timeouts during the fast start process
FSStabilizeInterval;	14500
FSFixFingersInterval;	15000
FSCheckPredInterval;	15500
buddyListSize;		22
callInterarrivalTime;	4887
maxCrawlerTimeouts;	5	
silentMode;		no
# Change transport protocol
transportProtocol;	udp
writeToLogFile;		yes
selfLookupInterval;	55000
useBogusRecordLookups;	no
useResNameInLookups;    no
dnsBasedBPDiscovery;    no
pollDnsTimer;           30000
sipInactivityTimer;     0
broadcastBPDiscovery;   no
useUnhashedIdInPeerIds; no
useICE;                	no
useTURNServerDiscovery;	no
worstCaseTURNDensity;   0.5
bubbleStormWeight;      5
bubbleStormMaxLookups;  5
bubbleStormSplitFactor; 1
bubbleStormParallel;    1
defaultNumOfServRcrds;  2
red5AsSipClient;        no
estimateOverlaySize;    no
disablePingFingers;     yes
keepaliveInterval;	60000
enableClients;		yes
disableTURN;		yes
skipTURNSrvrDiscovery;	yes
sipProxyMode;		no
plainSipProxyMode;	no
usePidginHacks;		no"  >> $BEGINFILENAME"0"$ENDFILENAME


echo "Generating Configuration Files for the rest... "

b=7000
for i in $(seq $n)
do
let b=b+5
echo "# Peer 4
# 1) Change the interface
interface;		eth0
useIPv6;		no	
useHIP;			no
useLocalLoopbackAddr;	no
# Is this peer the bootstrap peer?	
bootstrapMode;		no
# 2) Change the local port
localPort;		$b
userCommandMode;	no
# 3) Change address of the bootstrap peer
bootstrapPeerIP;	192.168.1.2
bootstrapPeerPort;	7000
randomUserName;		no
userName;		wn$i
centralNameAssignment;	no
# This value is in milliseconds
joinDelayInterval;	100
minLookupInterval;	300
maxLookupInterval;	600
minUptime;		288000
maxUptime;		288001	
leaveSupervisionTimer;	30
autoLookupNameRange;	1500
autoLookupSafetyMargin;	50	
successors;		5	
predecessors;		3
fingers;		5
logMode;		WARNING
useDhtCrawler;		yes
dhtCrawlerTimeout;	30
dhtCrawlerTtl;		2048
SIP_USER_AOR;		sip:alice@p2psip.net
sipServerPortLocal;	5067	
sipServerPortPublic;	5066
p2pOverlay;		p2psip.net
dontQueryNonExistUsers;	yes
usePrintServer;		no
printServerIP;		193.167.187.185
printServerPort;	55507
p2ppTimerT0;		5000
# Note: no need to configure T1 since it is initialized to T0
p2ppTimerT2;		30000
p2ppTimerT3;		30000
useTimerT3_B;		yes
# Transaction timer (TCP) for single-hop requests
p2ppTimerT3_B;		15000
usePingServer;		no
pingServerIP;		193.167.187.185
pingServerPort;		19876
maxPingRtt;		2500
disableSIP;		yes
maxAllowedTimeouts;	5
replicationFactor;	0	
# Maintenance timeouts
stabilizeInterval;	30000
fixFingersInterval;	30500
checkPredInterval;	31000
pingFingersInterval;    60000
# Fast startup related parameters
useFastStartUp;		no	
# This value is in milliseconds
joinIntervalFastStart;	4000	
networkSize;		10
measurementDuration;	144000	
# Maintenance timeouts during the fast start process
FSStabilizeInterval;	14500
FSFixFingersInterval;	15000
FSCheckPredInterval;	15500
buddyListSize;		22
callInterarrivalTime;	4887
maxCrawlerTimeouts;	5	
silentMode;		yes
# Change transport protocol
transportProtocol;	udp
writeToLogFile;		yes
selfLookupInterval;	55000
useBogusRecordLookups;	no
useResNameInLookups;    no
dnsBasedBPDiscovery;    no
pollDnsTimer;           30000
sipInactivityTimer;     0
broadcastBPDiscovery;   no
useUnhashedIdInPeerIds; no
useICE;                	no
useTURNServerDiscovery;	no
worstCaseTURNDensity;   0.5
bubbleStormWeight;      5
bubbleStormMaxLookups;  5
bubbleStormSplitFactor; 1
bubbleStormParallel;    1
defaultNumOfServRcrds;  2
red5AsSipClient;        no
estimateOverlaySize;    no
disablePingFingers;     yes
keepaliveInterval;	60000
enableClients;		yes
disableTURN;		yes
skipTURNSrvrDiscovery;	yes
sipProxyMode;		no
plainSipProxyMode;	no
usePidginHacks;		no"  >> $BEGINFILENAME$i$ENDFILENAME

done

echo "Launching Bootstrap Server in new terminal"
gnome-terminal -e "java -jar m2m.jar -c config_p0.txt" &
#java -jar m2m.jar -c config_p0.txt &
sleep 2

echo "Launching Simulated DHT Nodes with 5 seconds Intervals... "
for i in $(seq $n)
do
gnome-terminal -e "java -jar m2m.jar -c config_p$i.txt" &
#java -jar m2m.jar -c config_p$i.txt &
sleep 2
done

echo "Launching PN..."
gnome-terminal -e "/home/m2m/bin/pnlaunch" &
sleep 50
echo "Launching WN..."
gnome-terminal -e "/home/m2m/bin/wnlaunch" &
sleep 30
echo "Launching MCN..."
gnome-terminal -e "/home/m2m/bin/mcnlaunch" &


