package com.ericsson.p2psip.m2m;

import java.io.Serializable;


public class Bookkeeping implements Serializable{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 7328984355334570717L;
	/**
	 * Node's Bookkeeping information.
	 * Stores Record information of the PN/WN node and its associated LNs.
	 */
	/* The book number where the information of this node is stored. */
	private int mybooknumber;
	/* Number of added and removed nodes. */
	private ShortInfo shortinfo;
	/* For parsing the book where this node is stored. */
	private Book mybook;
	/* For parsing the list of joined and departed nodes. */
	private UpdateList ulist;
	/* The record information of this WN or PN. */
	private ProxyNode pnode;
			
	/**
	 * Constructs a new empty Book.
	 */
	public Bookkeeping() {
		this.mybooknumber = -1;
		this.shortinfo = new ShortInfo();
		this.ulist = new UpdateList();
		this.mybook = new Book();
		this.pnode = new ProxyNode();
	}

	public int getMybooknumber() {
		return mybooknumber;
	}

	public void setMybooknumber(int mybooknumber) {
		this.mybooknumber = mybooknumber;
	}

	public ShortInfo getShortinfo() {
		return shortinfo;
	}

	public void setShortinfo(ShortInfo shortinfo) {
		this.shortinfo = shortinfo;
	}

	public Book getMybook() {
		return mybook;
	}

	public void setMybook(Book mybook) {
		this.mybook = mybook;
	}

	public UpdateList getUlist() {
		return ulist;
	}

	public void setUlist(UpdateList ulist) {
		this.ulist = ulist;
	}

	public ProxyNode getPnode() {
		return pnode;
	}

	public void setPnode(ProxyNode pnode) {
		this.pnode = pnode;
	}

	
		

}