package com.ericsson.p2psip.m2m;

import java.io.Serializable;
import java.net.SocketException;
import java.rmi.Naming;
import java.rmi.RemoteException;

import com.ericsson.coap.endpoint.Endpoint;
import com.ericsson.coap.example.SampleServer;

public class M2MNodeExample implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1249439015386272081L;

	public static void main(String[] args) throws InterruptedException {
		/* Start the nodes */
		if (args.length < 1) {
			System.err.println("Wrong number of arguments. Usage: java -jar "
					+ "m2mce.jar -c config_file.txt ");
			System.exit(1);
		}
		int i = 0;
		if (args[i++].equals("-c")) {
			P2P4M2MCE.CONFIG_FILE = args[i].toString();
		} else {
			System.err.println("ERROR: -c is missing");
			return;
		}

		IM2M ce = null;
		try {
			ce = new P2P4M2MCE();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			System.out.println("Starting node: "
					+ ce.getBookData().getPnode().getPn().getName());
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		/* A PN or WN joins */
		String name = null;
		try {
			name = ce.getBookData().getPnode().getPn().getName();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			ce.join(name, true);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
