package com.ericsson.p2psip.m2m;

import java.net.SocketException;
import java.rmi.RemoteException;

import com.ericsson.coap.endpoint.Endpoint;
import com.ericsson.coap.example.SampleClient;
import com.ericsson.p2psip.m2m.P2P4M2MCE;
import com.ericsson.p2psip.util.IPEndpoint;


public class M2MNodeExampleApp {


	public static void main (String[] args) throws InterruptedException {
		/* Start the nodes*/
		if(args.length < 1) {
			System.err.println("Wrong number of arguments. Usage: java -jar "
					+ "m2mce.jar -c config_file.txt ");
			System.exit(1);
		}
		int i = 0;
		if (args[i++].equals("-c")) {
			P2P4M2MCE.CONFIG_FILE = args[i].toString();
		}
		else {
			System.err.println("ERROR: -c is missing");
			return;
		}		

		IM2M ce = null;
		try {
			ce = new P2P4M2MCE();
		} catch (RemoteException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

		try {
			System.out.println("Starting node: " + ce.getBookData().getPnode().getPn().getName());
		} catch (RemoteException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

		/* A PN or WN joins*/
		String name = null;
		IPEndpoint ipofjaime = null;
		try {
			name = ce.getBookData().getPnode().getPn().getName();
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		try {
			ce.join(name, true);
			ipofjaime = ce.getIP("jaime");
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		String[] argss = new String[]{"POST","coap://"+ ipofjaime.getIpAddress()+":5683/proxy", "jaime/ln0:Blink"};
		SampleClient.main(argss);
		
//		try {
//
//			Endpoint server = new SampleServer();
//
//			System.out.printf("SampleServer listening at port %d.\n", server.port());
//
//		} catch (SocketException e) {
//
//			System.err.printf("Failed to create SampleServer: %s\n", 
//					e.getMessage());
//
//			
//		}
	}

}
