package com.ericsson.p2psip.m2m;

import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

public class M2mCeRmiInstance {

	public static void main(String[] args) throws InterruptedException, RemoteException  {
		/* Start the nodes */
		if (args.length < 1) {
			System.err.println("Wrong number of arguments. Usage: java -jar "
					+ "m2mce.jar -c config_file.txt ");
			System.exit(1);
		}
		int i = 0;
		if (args[i++].equals("-c")) {
			P2P4M2MCE.CONFIG_FILE = args[i].toString();
		} else {
			System.err.println("ERROR: -c is missing");
			return;
		}

		IM2M ce = null;
		try {
			ce = new P2P4M2MCE();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


                // Create and install a security manager
                if (System.getSecurityManager() == null) {
                    System.setSecurityManager(new RMISecurityManager());
                    System.out.println("Security manager installed.");
                } else {
                    System.out.println("Security manager already exists.");
                }
         
                Registry registry = null;
                try { //special exception handler for registry creation
                	registry = LocateRegistry.createRegistry(1099); 
                    System.out.println("java RMI registry created.");
                } catch (RemoteException e) {
                    //do nothing, error means registry already exists
                    System.out.println("java RMI registry already exists.");
                    registry = LocateRegistry.getRegistry();
                }

		String rmiName = "M2MCE";
		if (args.length == 3)
		{
			rmiName =  "M2MCE" + args[2];
            System.out.println("Binding with name " + rmiName);
		}
		
		try {
			//Naming.bind(rmiName, ce);
			registry.rebind(rmiName, ce);
		} catch (Exception e) {
			System.err.println("M2MCE RMI server binding error .Terminating the program.");
			e.printStackTrace();
			return;
		}
		System.out.println("M2MCE RMI server started with name " + rmiName);

/*
        // This is done through SNMP-agent so that the name can be dynamic
		String name = null;
		try {
			name = ce.getBookData().getPnode().getPn().getName();
			System.out.println("Starting local node: " + name);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		try {
			ce.join(name, true);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
*/
	}

}
