package com.ericsson.p2psip.m2m;

/**
 * A class representing the result of a callback from P2P4M2MEngine
 * @author ejoumae
 *
 */
public class P2P4M2MCallbackResult {

	/**
	 * The operation was successful
	 */
	public static final int SUCCESS = 0;
	
	/**
	 * The operation failed
	 */
	public static final int FAILED = 1;
	
	/**
	 * Indicates the result of the operation
	 */
	int code;
	
	/**
	 * Create a new P2P4M2MCallbackResult instance
	 * @param code indicates the result of the operation
	 */
	public P2P4M2MCallbackResult(int code) {
		this.code = code;
	}
	
	/**
	 * Get a string representation of this object
	 */
	public String toString() {
		String result = "";
		switch(this.code) {
		case SUCCESS : result = "success"; break;
		case FAILED : result = "failed"; break;
		default : result = "unknown"; break;
		}
		return result;
	}
	
}
