//package com.ericsson.p2psip.m2m;
//
//import java.io.BufferedReader;
//import java.io.InputStreamReader;
//import java.util.Arrays;
//import java.util.Date;
//
//import com.ericsson.p2psip.logger.LogWriter;
//import com.ericsson.p2psip.logger.P2pSipLogger;
//import com.ericsson.p2psip.p2ppparser.EncodedSequence;
//import com.ericsson.p2psip.util.AppUtils;
//import com.ericsson.p2psip.util.ConfigData;
//
//
//public class P2P4M2MMain implements IP2P4M2MCallback {
//	
//	
//	/**
//	 * The configuration file
//	 */
//	public static String CONFIG_FILE;
//	/**
//	 * The logger
//	 */
//	private P2pSipLogger logger;
//	/**
//	 * The P2P4M2MEngine
//	 */
//	private IP2P4M2M engine;
//	/**
//	 * For storing bookkeeping data
//	 */
//	private P2P4M2MBookkeeping bookData;
//	/**
//	 * For storing lookups
//	 */
//	private P2P4M2MLookUps lu;
//	/**
//	 * Used for handling user input
//	 */
//    private BufferedReader stdin;
//    /**
//     * Indicates whether this peer has joined the overlay or not
//     */
//    private boolean joined;
//	
//    /**
//     * Create a P2P4M2MMain instance
//     */
//	public P2P4M2MMain() {
//		
//		this.joined = false;
//		this.logger = P2pSipLogger.getInstance("P2P4M2MMain");
//		this.engine = new P2P4M2MEngine(this);
//		P2P4M2MEngine temp = (P2P4M2MEngine) this.engine;
//		
//		this.lu = new P2P4M2MLookUps();
//		this.bookData = new P2P4M2MBookkeeping();
//		Date timestamp = new Date();
//		P2P4M2MRecord record = new P2P4M2MRecord(temp.getName(), temp.getIPEndpoint(), timestamp.getTime(), 0); 
//		System.out.println("Local IP is " + temp.getIPEndpoint().toString()+ ".");
//		System.out.println("Local name is " + temp.getName() + ".");
//		this.bookData.setMyrecord(record);
//		System.out.println("Record is: "+  Arrays.toString(record.getBytes()));
//		System.out.println("IP is: "+  Arrays.toString(temp.getIPEndpoint().getIpPortBytes20()));
//		
//		
//		
//		if(temp.getConfig().getBooleanProperty(ConfigData.BOOTSTRAP_MODE)) {
//			/*
//			 * The bootstrap peer does not need to join 
//			 */
//			this.joined = true;
//			
//			/**
//			 * INITIALIZE BOOKKEEPING and Bootstrap Peer info
//			 */
//			/*****************************************************************************************************************/
//			
////			//book.insertAtEndRecord(record);
////			EncodedSequence eS = new EncodedSequence(this.bookData.getMybook().getLength());  
////			this.bookData.getMybook().encode(eS);
//			P2P4M2MShortInfo bpinfo = new P2P4M2MShortInfo();
//			// Store Short Generic Information
//			engine.asyncStore((new Long((new Date()).getTime())).toString(), M2MCEKeys.SHORTINFO, bpinfo.getBytes());
//			// Store First Book 
//			engine.asyncStore((new Long((new Date()).getTime())).toString(), M2MCEKeys.LASTBOOK,new byte[0]);
//			// Store Name-IP of BP
//			engine.asyncStore((new Long((new Date()).getTime())).toString(), 
//					this.bookData.getMyrecord().getName(), this.bookData.getMyrecord().getIp().getIpPortBytes20());
//			/*****************************************************************************************************************/
//			
//		}
//		
//		logger.logToConsole("P2P4M2MEngine was created.", P2pSipLogger.INFO, 
//				"P2P4M2MMain");
//		stdin = new BufferedReader(new InputStreamReader(System.in));
//		
//		
//		/*
//		 * Join the Overlay
//		 */
//		engine.asyncJoin();
//		
//		/*
//		 * Process user input from the console
//		 */
//		while(true) {
//			System.out.println("Give a command. For help, press 'h'");
//			String command = AppUtils.readLine(stdin);
//			processCommand(command);
//		}		
//	}
//	
//	
//	/**
//	 * Process a command given by a user
//	 * @param command
//	 */
//	private void processCommand(String command) {
//		if(command.equalsIgnoreCase("q")) {
//			/*
//			 * Terminate the application
//			 */
//			LogWriter.getInstance().close();
//			System.exit(0);
//		}
//		else if(command.equalsIgnoreCase("h")) {
//			System.out.println("===========");
//			System.out.println("Get:    'g'");
//			System.out.println("Help:   'h'");
//			//System.out.println("Join:   'j'");
//			System.out.println("Put:    'p'");
//			System.out.println("Leave:  'l'");
//			System.out.println("Quit:   'q'");
//			System.out.println("Remove: 'r'");
//			System.out.println("===========");
//			
//		}	
////		else if(command.equalsIgnoreCase("j")) {
////			/*
////			 * Join the overlay
////			 */
////			engine.asyncJoin();
////			
////		}
//		else if(command.equalsIgnoreCase("g")) {
//			/*
//			 * Get operation
//			 */
//			if(!joined) {
//				System.out.println("Please join first!");
//				return;
//			}
//			System.out.println("Give a key: ");
//			String key = AppUtils.readLine(stdin);
//			engine.asyncLookup(
//					(new Long((new Date()).getTime())).toString(), key);
//			
//		
//		}
//		else if(command.equalsIgnoreCase("p")) {
//			/*
//			 * Put operation
//			 */
//			if(!joined) {
//				System.out.println("Please join first!");
//				return;
//			}
//			System.out.println("Give a key: ");
//			String key = AppUtils.readLine(stdin);
//			System.out.println("Give a value: ");
//			String value = AppUtils.readLine(stdin);
//			engine.asyncStore(
//					(new Long((new Date()).getTime())).toString(), key,
//					value.getBytes());
//		}
//		else if(command.equalsIgnoreCase("l")) {
//			/*
//			 * Leave operation
//			 */
//			if(!joined) {
//				System.out.println("Please join first!");
//				return;
//			}
//			
//			// Look for ShortInfo.
//			this.lu.setLookup_shortinfo_leave((new Long((new Date()).getTime())).toString());
//			engine.asyncLookup(this.lu.getLookup_shortinfo_leave(), M2MCEKeys.SHORTINFO);
//			// Look for Name.
//			this.lu.setLookup_name_leave((new Long((new Date()).getTime())).toString());
//			engine.asyncLookup(this.lu.getLookup_name_leave(),  this.bookData.getMyrecord().getName());
//			// Look for last book
//			this.lu.setLookup_last_book_leave((new Long((new Date()).getTime())).toString());
//			engine.asyncLookup(this.lu.getLookup_last_book_leave(), M2MCEKeys.LASTBOOK);
//		
//			/*
//			 * Remove node from Database
//			 */
//			// Decrement added Nodes
//			// Remove Node Info
//			
//		
//			engine.asyncLeave();
//		}
//		else if(command.equalsIgnoreCase("r")) {
//			/*
//			 * Remove operation
//			 */
//			if(!joined) {
//				System.out.println("Please join first!");
//				return;
//			}
//			System.out.println("Give a key: ");
//			String key = AppUtils.readLine(stdin);
//			engine.asyncRemove(
//					(new Long((new Date()).getTime())).toString(), key);
//		}
//	}
//
//
//		
//	/**
//	 * The main method
//	 * @param args
//	 */
//	public static void main(String[] args) {
//		if(args.length < 1) {
//			System.err.println("Wrong number of arguments. Usage: java -jar "
//					+ "m2mce.jar -c config_file.txt ");
//			System.exit(1);
//		}
//		int i = 0;
//		if (args[i++].equals("-c")) {
//			P2P4M2MMain.CONFIG_FILE = args[i].toString();
//		}
//		else {
//			System.err.println("ERROR: -c is missing");
//			return;
//		}		
//		
//		System.out.println("===COMMANDS===");
//		System.out.println("Get:    'g'");
//		System.out.println("Help:   'h'");
//		//System.out.println("Join:   'j'");
//		System.out.println("Put:    'p'");
//		System.out.println("Leave:  'l'");
//		System.out.println("Quit:   'q'");
//		System.out.println("Remove: 'r'");
//		System.out.println("===========");
//		P2P4M2MMain main = new P2P4M2MMain();
//	}
//	
//	
//	/**
//	 * @inheritDoc
//	 */
//	public void joinReady(P2P4M2MCallbackResult result) {
//		logger.logToConsole("P2P4M2MMain.joinReady( ): result: " + result, 
//				P2pSipLogger.INFO);
//		this.joined = true;
//		
//		// NOW we have joined, we should store our info in the overlay.
//		
//		// Look for ShortInfo.
//		logger.logToConsole("P2P4M2MMain.joinReady( ): Now Looking for: " + M2MCEKeys.SHORTINFO,4);
//		this.lu.setLookup_shortinfo_join((new Long((new Date()).getTime())).toString());
//		engine.asyncLookup(this.lu.getLookup_shortinfo_join(), M2MCEKeys.SHORTINFO);
//		
//		// Insert CoAP Name and Address. 
//		logger.logToConsole("P2P4M2MMain.joinReady( ): Now Looking for: " + this.bookData.getMyrecord().getName().toString(),4);
//		engine.asyncStore((new Long((new Date()).getTime())).toString(), 
//				this.bookData.getMyrecord().getName(), this.bookData.getMyrecord().getIp().getIpPortBytes20());
//		
//		// Look for last book
//		logger.logToConsole("P2P4M2MMain.joinReady( ): Now Looking for: " + M2MCEKeys.LASTBOOK,4);
//		this.lu.setLookup_last_book_join((new Long((new Date()).getTime())).toString());
//		engine.asyncLookup(this.lu.getLookup_last_book_join(), M2MCEKeys.LASTBOOK);
//	
//	}
//	
//	/**
//	 * @inheritDoc
//	 */
//	public void leaveReady(P2P4M2MCallbackResult result) {
//		logger.logToConsole("P2P4M2MMain.leaveReady( ): result: " + result, 
//				P2pSipLogger.INFO);
//	}
//	
//	/**
//	 * @inheritDoc
//	 */
//	public void lookupReady(P2P4M2MLookupResult result) {
//		
//		printLookUpResult(result);
//		String lookup = result.getLookupID();
//		if (result.getStatus() == P2P4M2MLookupResult.SUCCESS){
//
//			
//			if(lookup.equals(lu.getLookup_shortinfo_join())){
//				/* If the node is JOINING modifies SHORT_INFO */
//				P2P4M2MShortInfo info = P2P4M2MShortInfo.parse(new EncodedSequence(result.getData()));
//				int added = info.getAdded_nodes()+1;
//				info.setAdded_nodes(added);
//				this.bookData.setShortinfo(info);
//				
//				engine.asyncStore((new Long((new Date()).getTime())).toString(), M2MCEKeys.SHORTINFO, info.getBytes());
//				info.print();	
//			}
//			
//			else if(lookup.equals(lu.getLookup_shortinfo_leave())){
//				/* If the node is LEAVING modifies SHORT_INFO */
//				P2P4M2MShortInfo info = P2P4M2MShortInfo.parse(new EncodedSequence(result.getData()));
//				int departed = info.getDeparted_nodes()+1;
//				info.setDeparted_nodes(departed);
//				this.bookData.setShortinfo(info);
//				
//				engine.asyncStore((new Long((new Date()).getTime())).toString(), M2MCEKeys.SHORTINFO, info.getBytes());
//				info.print();
//			}
//			
//			else if(lookup.equals(lu.getLookup_last_book_join())){
//				/* If the node is JOINING get LAST_BOOK */
//				P2P4M2MBook book = new P2P4M2MBook();
//				if (result.getData().length != 0){
//					book = P2P4M2MBook.parse(new EncodedSequence(result.getData()));	
//				}				
//				book.insertAtEndRecord(this.bookData.getMyrecord());
//				this.bookData.setMybook(book);
//				this.bookData.setMybookposition(this.bookData.getMybook().getVook().size() -1 );
//				
//				engine.asyncStore((new Long((new Date()).getTime())).toString(), M2MCEKeys.LASTBOOK, book.getBytes());
//				System.out.print("My position is: "+ this.bookData.getMybookposition() + " ");
//				book.print();
//			}
//
//			else if(lookup.equals(lu.getLookup_last_book_leave())){
//				/* If the node is LEAVING get LAST_BOOK */
//				P2P4M2MBook book = new P2P4M2MBook();
//				if (result.getData().length != 0){
//					book = P2P4M2MBook.parse(new EncodedSequence(result.getData()));	
//				}	
//				P2P4M2MRecord r = this.bookData.getMyrecord();
//				Date timestamp = new Date();
//				r.setT_leave(timestamp.getTime());
//				this.bookData.setMyrecord(r);
//				book.setRecord(this.bookData.getMyrecord(), this.bookData.getMybookposition());
//				this.bookData.setMybook(book);
//				
//				engine.asyncStore((new Long((new Date()).getTime())).toString(), M2MCEKeys.LASTBOOK, book.getBytes());
//
//				book.print();
//			}
//			
//			else if(lookup.equals(lu.getLookup_name_leave())){
//				/* If the node is LEAVING removes Name-IP */
//				engine.asyncRemove((new Long((new Date()).getTime())).toString(), this.bookData.getMyrecord().getName());
//				
//			}
//			else{
//				logger.logToConsole("LookupReady LookUpID is Unknown: " + result.toString(),
//						P2pSipLogger.INFO);
//			}
//		}
//		else if (result.getStatus() == P2P4M2MLookupResult.FAILURE){
//			logger.logToConsole("LookupReady results was a FAILURE: " + result.toString(),
//					P2pSipLogger.INFO);
//		}
//
//		else {
//			logger.logToConsole("LookupReady results is Strange: " + result.toString(),
//					P2pSipLogger.INFO);
//		}		
//	}
//
//
//	private void printLookUpResult(P2P4M2MLookupResult result) {
//		logger.logToConsole("Lookup results received: " + result.toString(),
//				P2pSipLogger.INFO);
//		
//		if(result.getData() != null) {
//			logger.logToConsole("Value: " + Arrays.toString(result.getData()), 
//					P2pSipLogger.INFO);
////			logger.logToConsole("Lookup results received: " + BitOperations.intBytesToString(result.getData()),
////					P2pSipLogger.INFO);
//		}
//	}
//	
//	/**
//	 * @inheritDoc
//	 */
//	public void storeReady(String storeID, P2P4M2MCallbackResult result) {
//		logger.logToConsole("P2P4M2MMain.storeReady( ): result: " + result, 
//				P2pSipLogger.INFO);	
//	}
//
//	/**
//	 * @inheritDoc
//	 */
//	public void removeReady(String removeID, P2P4M2MCallbackResult result) {
//		logger.logToConsole("P2P4M2MMain.removeReady( ): result: " + result, 
//				P2pSipLogger.INFO);		
//	}
////	
////	public void get(String key) {
////		if(!joined) {
////			System.out.println("Please join first!");
////			return;
////		}
////		engine.asyncLookup(
////				(new Long((new Date()).getTime())).toString(), key);
////	}
////
////	public void get(byte[] key) {
////		if(!joined) {
////			System.out.println("Please join first!");
////			return;
////		}
////		engine.asyncLookup(
////				(new Long((new Date()).getTime())).toString(), key);
////	}
////	
////	public void put(byte[] key, byte[] value) {
////		if(!joined) {
////			System.out.println("Please join first!");
////			return;
////		}
////		engine.asyncStore(
////				(new Long((new Date()).getTime())).toString(), key,
////				value);
////	}
////	
////	public void put(String key, byte[] value) {
////		if(!joined) {
////			System.out.println("Please join first!");
////			return;
////		}
////		engine.asyncStore(
////				(new Long((new Date()).getTime())).toString(), key,
////				value);
////	}
////
////	public void join() {
////		engine.asyncJoin();
////	}
////	
////	public void join(String coapName) {
////		// MAKE RECORD of CoAP Name and store it
////	}
////	
////	public void leave(String coapName) {
////		// Make Bookkeeping of CoAP Name and store it also bookposition
////	}
//	
//}
