package com.ericsson.p2psip.m2m;

import java.io.Serializable;

import com.ericsson.p2psip.p2ppparser.EncodedSequence;


public class ShortInfo implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -2886024799194108071L;

	public static final int TOTALLENGTH_BYTES = 8;
	
	private int added_nodes;
	private int departed_nodes;


	public ShortInfo() {
		this.added_nodes = 0;
		this.departed_nodes = 0;
	}

	
	public ShortInfo(int added_nodes, int departed_nodes) {

		this.added_nodes = added_nodes;
		this.departed_nodes = departed_nodes;
	}

	public static ShortInfo parse(EncodedSequence encodedSequence) {
		ShortInfo info = new ShortInfo(); 
		info.setAdded_nodes(encodedSequence.parseInt());
		info.setDeparted_nodes(encodedSequence.parseInt());
		return info;
	}


	public int getAdded_nodes() {
		return added_nodes;
	}


	public void setAdded_nodes(int added_nodes) {
		this.added_nodes = added_nodes;
	}


	public int getDeparted_nodes() {
		return departed_nodes;
	}


	public void setDeparted_nodes(int departed_nodes) {
		this.departed_nodes = departed_nodes;
	}


	@Override
	public String toString() {
		return "ShortInfo [added_nodes=" + added_nodes
				+ ", departed_nodes=" + departed_nodes + "]";
	}
	
	public byte[] getBytes() {
		EncodedSequence encodedSequence = new EncodedSequence(TOTALLENGTH_BYTES);
		encodedSequence.addInt(added_nodes);
		encodedSequence.addInt(departed_nodes);
		return encodedSequence.getBytes();
	}


	public void print() {
		System.out.println("{"+added_nodes+" | "+departed_nodes+"}");
		
	}
	

}