package com.ericsson.p2psip.m2m;

import java.io.Serializable;
import java.util.Vector;

import com.ericsson.p2psip.p2ppparser.EncodedSequence;


public class UpdateList implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 4563794882258475259L;
	private int nupdts;
	private Vector<NameIP> nameiplist;
		
	public UpdateList() {
		this.nupdts = 0;
		this.nameiplist = new Vector<NameIP>();
	}
	

	public UpdateList(UpdateList another) {
		this.nupdts = another.nupdts;
		this.nameiplist = new Vector<NameIP>();
		for(int i=0; i<another.nameiplist.size(); i++) {
			this.nameiplist.addElement(another.nameiplist.elementAt(i));
		}
	}

	public static UpdateList parse(EncodedSequence encodedSequence) {
		UpdateList n = new UpdateList();
		n.setNupdts(encodedSequence.parseInt());
		Vector<NameIP> nameiplist =  new Vector<NameIP>();
		for(int i=0; i<n.getNupdts(); i++) {
			NameIP entry = NameIP.parse(encodedSequence);
			nameiplist.addElement(entry);
		}						
		n.setNameiplist(nameiplist);
		return n;
	}

	public byte[] encode(EncodedSequence encodedSequence){
		encodedSequence.addInt(this.nupdts);
		for (int i=0; i < this.nupdts; i++ ){
			NameIP entry = (NameIP) nameiplist.elementAt(i);
			entry.encode(encodedSequence);
		}
		return encodedSequence.getBytes();
	}

	public byte[] getBytes() {
		EncodedSequence encodedSequence = new EncodedSequence(this.getLength());
		encodedSequence.addInt(this.nupdts);
		for (int i=0; i < this.nupdts; i++ ){
			NameIP entry = (NameIP) nameiplist.elementAt(i);
			entry.encode(encodedSequence);
		}
		return encodedSequence.getBytes();
	}

	public int getLength() {
		return 4 + (this.nameiplist.size()*NameIP.LENGTH);		
	}

	public void print() {
		if (nupdts >0) {
			System.out.println ("  Update List :");
			for (int i=0; i < this.nameiplist.size(); i++ ){
				NameIP entry = (NameIP) nameiplist.elementAt(i);
				System.out.println ("     " + i + entry.toString());	
			}
		}
		//System.out.println ("}");
	}


	public void addnameip(NameIP nameip) {
		this.nameiplist.add(nameip);
		this.setNupdts(nupdts +1 );
		
	}


	public int getNupdts() {
		return nupdts;
	}


	public void setNupdts(int nupdts) {
		this.nupdts = nupdts;
	}


	public Vector<NameIP> getNameiplist() {
		return nameiplist;
	}


	public void setNameiplist(Vector<NameIP> nameiplist) {
		this.nameiplist = nameiplist;
	}
	

}